/*
 * $Id: dlg_load.h 7334 2010-10-27 12:04:49Z anca_vamanu $
 *
 * dialog module - basic support for dialog tracking
 *
 * Copyright (C) 2006 Voice Sistem SRL
 *
 * This file is part of opensips, a free SIP server.
 *
 * opensips is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version
 *
 * opensips is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * History:
 * --------
 *  2006-04-14  initial version (bogdan)
 */

#ifndef _DIALOG_DLG_LOAD_H_
#define _DIALOG_DLG_LOAD_H_

#include "dlg_cb.h"
#include "dlg_handlers.h"
#include "dlg_profile.h"
#include "dlg_vals.h"
#include "../../sr_module.h"

typedef struct dlg_cell *(*get_dlg_f)( void );

struct dlg_binds {
	register_dlgcb_f     register_dlgcb;
	create_dlg_f         create_dlg;
	get_dlg_f            get_dlg;
	add_profiles_f       add_profiles;
	search_dlg_profile_f search_profile;
	set_dlg_profile_f    set_profile;
	set_dlg_profile_f    unset_profile;
	get_profile_size_f   get_profile_size;
	store_dlg_value_f    store_dlg_value;
	fetch_dlg_value_f    fetch_dlg_value;
	terminate_dlg_f      terminate_dlg;
};


typedef int(*load_dlg_f)( struct dlg_binds *dlgb );
int load_dlg( struct dlg_binds *dlgb);


static inline int load_dlg_api( struct dlg_binds *dlgb )
{
	load_dlg_f load_dlg;

	/* import the DLG auto-loading function */
	if ( !(load_dlg=(load_dlg_f)find_export("load_dlg", 0, 0)))
		return -1;

	/* let the auto-loading function load all DLG stuff */
	if (load_dlg( dlgb )==-1)
		return -1;

	return 0;
}


#endif
